package com.miyzh.service;

import com.miyzh.entity.Clinic;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Slf4j
@Service
public class BaseService {

    @Autowired
    private ClinicService clinicService;

    @Autowired
    private MedicineStoreService medicineStoreService;
    @Autowired
    private MedicineStorageService medicineStorageService;


    public void runService () {
        try{
            long startTime = System.currentTimeMillis();
            List<Clinic> clinicList = clinicService.listClinic();
//            storeUploadService.uploadMedicine(clinicList);
//            medicineStoreService.uploadChinaMedicine(clinicList);
            medicineStorageService.uploadMedicine(clinicList);

            long syncTime = System.currentTimeMillis();
            log.info("总耗时--{}", startTime - syncTime);
        } catch (Exception e) {
            e.printStackTrace();
            log.error(e.getMessage());
        }

    }



}
